apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ kibana_name }}-mp-helpers
  namespace: {{ namespace }}
data:
  makepattern-helper.sh: |
    #!/bin/sh

    if test "$DEBUG"; then
        set -x
    fi
    if test -z "$KIBANA_URL"; then
        KIBANA_URL=http://127.0.0.1:5601
    fi

    IDXID=${IDXID:-cd46d9b0-2cd9-11eb-807f-6fb1a73a8c7e}
    WAIT_INTERVAL=${WAIT_INTERVAL:-10}
    WAIT_MAX_RETRY=${WAIT_MAX_RETRY:-30}
    if test -z "$PATTERN"; then
        PATTERN="logstash-*"
    fi

    echo Waiting for Kibana
    c=0
    while test $c -lt $WAIT_MAX_RETRY
    do
        if curl --connect-timeout 5 "$KIBANA_URL" >/dev/null 2>&1; then
            echo OK
            break
        fi
        c=`expr $c + 1`
        sleep $WAIT_INTERVAL
    done
    if test $c -eq $WAIT_MAX_RETRY; then
        echo Failed contacting Kibana - bailing out
        test "$DEBUG" && sleep 60
        exit 1
    fi

    if ! curl --connect-timeout 5 \
            "$KIBANA_URL/api/saved_objects/index-pattern/$IDXID" \
            2>/dev/null | grep "$IDXID" >/dev/null; then
        echo Pattern already exists
        exit 0
    fi

    if ! curl -f -X POST --connect-timeout 5 \
            --header 'Content-Type: application/json' \
            --header 'kbn-xsrf: this_is_required_header' \
            --data "{\"attributes\":{\"title\":\"$PATTERN\",\"timeFieldName\":\"@timestamp\"}}" \
            "$KIBANA_URL/api/saved_objects/index-pattern/$IDXID?overwrite=true"; then
        echo Failed creating index pattern
        exit 1
    fi

    exit 0
